﻿
Enumeration
  #Window
  
  #File
  
  #PalCanvas
  #ScreenCanvas
  #CheckBoxBorder
  #CheckBoxGreed
  #ColorGreen
  #ColorPurple
  #ColorBlack
  #PrioritetMirrorsCanvas
  
  #Test
EndEnumeration

Global Granica.a, Setka.a
Global GreedColor.l, BorderColor.l
; и в начале выбранный цвет будет зеленым
BorderColor = RGB(0, 200, 0)
GreedColor  = RGBA(0, 200, 0, 100)

; как пазлы добавляем нужные части.

;{ битовые операции
Macro SetBit(Var, Bit)   ; Установка бита.
  Var | (Bit)
EndMacro 
Macro ClearBit(Var, Bit) ; Обнуление бита.
  Var & (~(Bit))
EndMacro 
Macro TestBit(Var, Bit)  ; Проверить бит
  Bool(Var & (Bit))
EndMacro
Macro NumToBit(Num)      ; Позиция бита по его номеру. ; для вызова сет бит и клер бит.
  (1<<(Num))
EndMacro
Macro GetBits(Var, StartPos, EndPos) ; Прочитать от и до
  ((Var>>(StartPos))&(NumToBit((EndPos)-(StartPos)+1)-1))
EndMacro
;}

;{ для палитры
; массив с кодами цветов
Global Dim SegaSegmentColor.a(16)
; 0, 36, 72, 109, 145, 181, 219, 255
SegaSegmentColor(2)  =  36
SegaSegmentColor(4)  =  72
SegaSegmentColor(6)  = 109
SegaSegmentColor(8)  = 145
SegaSegmentColor(10) = 181
SegaSegmentColor(12) = 219
SegaSegmentColor(14) = 255

; создаем сложный массив с 4 колонками и 16 строчек в каждой. как Ексель таблица.
Structure colorstructure
  ColorNum.l[17] 
EndStructure
Global Dim PalNum.colorstructure(4)

; читаем файл с палитрами.
If ReadFile(#File, "pal.bin")
  
  ; первая палитра
  pal = 1
  For colornumindex = 0 To 15
    ; по 2 байта на bgr цвет
    ; в первом из двух лежит только один сегмент - blue - b
    b    = ReadAsciiCharacter(#File)
    ; во втором байте два цвета green и red - g и r
    temp = ReadAsciiCharacter(#File)
    g    = temp >> 4 ; наш любимый сдвиг. здесь на 4 бита вправо и это превратит число $12 в $1
    r    = temp & $F
    ; теперь подготавливаем код цвета GRB 
    NormalRGBColor.l = RGB(SegaSegmentColor(r), SegaSegmentColor(g), SegaSegmentColor(b))
    ; и вносим его в нужную ячейку таблицы
    PalNum(pal)\ColorNum[colornumindex] = NormalRGBColor
  Next
  
  ; вторая палитра
  pal = 2
  For colornumindex = 0 To 15
    ; по 2 байта на bgr цвет
    ; в первом из двух лежит только один сегмент - blue - b
    b    = ReadAsciiCharacter(#File)
    ; во втором байте два цвета green и red - g и r
    temp = ReadAsciiCharacter(#File)
    g    = temp >> 4 ; наш любимый сдвиг. здесь на 4 бита вправо и это превратит число $12 в $1
    r    = temp & $F
    ; теперь подготавливаем код цвета GRB 
    NormalRGBColor.l = RGB(SegaSegmentColor(r), SegaSegmentColor(g), SegaSegmentColor(b))
    ; и вносим его в нужную ячейку таблицы
    PalNum(pal)\ColorNum[colornumindex] = NormalRGBColor
  Next
  
  ; третья палитра
  pal = 3
  For colornumindex = 0 To 15
    ; по 2 байта на bgr цвет
    ; в первом из двух лежит только один сегмент - blue - b
    b    = ReadAsciiCharacter(#File)
    ; во втором байте два цвета green и red - g и r
    temp = ReadAsciiCharacter(#File)
    g    = temp >> 4 ; наш любимый сдвиг. здесь на 4 бита вправо и это превратит число $12 в $1
    r    = temp & $F
    ; теперь подготавливаем код цвета GRB 
    NormalRGBColor.l = RGB(SegaSegmentColor(r), SegaSegmentColor(g), SegaSegmentColor(b))
    ; и вносим его в нужную ячейку таблицы
    PalNum(pal)\ColorNum[colornumindex] = NormalRGBColor
  Next
  
  ; четвертая палитра
  pal = 4
  For colornumindex = 0 To 15
    ; по 2 байта на bgr цвет
    ; в первом из двух лежит только один сегмент - blue - b
    b    = ReadAsciiCharacter(#File)
    ; во втором байте два цвета green и red - g и r
    temp = ReadAsciiCharacter(#File)
    g    = temp >> 4 ; наш любимый сдвиг. здесь на 4 бита вправо и это превратит число $12 в $1
    r    = temp & $F
    ; теперь подготавливаем код цвета GRB 
    NormalRGBColor.l = RGB(SegaSegmentColor(r), SegaSegmentColor(g), SegaSegmentColor(b))
    ; и вносим его в нужную ячейку таблицы
    PalNum(pal)\ColorNum[colornumindex] = NormalRGBColor
  Next
  
  CloseFile(#File)
  
  palfile = 1 ; просто метка, что файл палитры прочитался
  
Else
  ; добавляем текст ошибки, на случай если файла палитры нет
  MessageRequester("ошибка", "нет файла палитры")
EndIf
;}

;{ тайловый сет.
; делаем метку на память и размер глобальными переменными, чтобы любая процедура могла их читать
Global tsetmemory.l
Global tsetsize.l

; тут просто чтение и загон содержимого файла в память
If ReadFile(#File, "tset.bin")
  ; получаем размер открытого файла
  tsetsize = Lof(#File)
  If tsetsize
    ; если размер больше 0 байт
    
    ; резервируем память нужного размера
    tsetmemory = AllocateMemory(tsetsize)
    If tsetmemory
      ; если память зарезервировалась
      
      ; читаем из открытого файла в память
      ReadData(#File, tsetmemory, tsetsize)
    EndIf
  Else
    ; добавляем текст ошибки, на случай если файл тайл сета 0 байт - пустой
    MessageRequester("ошибка", "файл тайл сета по всей видимости пуст - 0 байт")
  EndIf
  CloseFile(#File)
Else
  ; добавляем текст ошибки, на случай если файла тайл сета нет
  MessageRequester("ошибка", "нет файла тайл сета")
EndIf
;}

;{ тайловая карта.
; делаем метку на память и размер глобальными переменными, чтобы любая процедура могла их читать
Global tmapmemory.l
Global tmapsize.l

; тут просто чтение и загон содержимого файла в память
If ReadFile(#File, "tmap.bin")
  ; получаем размер открытого файла
  tmapsize = Lof(#File)
  If tmapsize
    ; если размер больше 0 байт
    
    ; резервируем память нужного размера
    tmapmemory = AllocateMemory(tmapsize)
    If tmapmemory
      ; если память зарезервировалась
      
      ; читаем из открытого файла в память
      ReadData(#File, tmapmemory, tmapsize)
    EndIf
  Else
    ; добавляем текст ошибки, на случай если файл тайловой карты 0 байт - пустой
    MessageRequester("ошибка", "файл тайловой карты по всей видимости пуст - 0 байт")
  EndIf
  CloseFile(#File)
Else
  ; добавляем текст ошибки, на случай если файла тайловой карты не существует
  MessageRequester("ошибка", "нет файла тайловой карты")
EndIf
;}

;{ проверяем что у нас все есть в наличии и палитра и тайловая карта и тайловый сет
If palfile And tmapmemory And tsetmemory
  ; все хорошо, едем дальше
Else
  ; программа просто завершается, так как текст ошибки, что какого-то файла нет - уже был показан
  End
EndIf
;}

;{ процедура для рисования тайла
Procedure RisuemTile(startx.u, starty.u, memory.l, pal.a, xmir.a, ymir.a)
  
  ; счетчик сдвига в памяти
  k = 0
  
  ; расчет докуда крутить по Х и по У
  endx = startx + 7
  endy = starty + 7 
  
  ; двойная проверка на зеркала - итого 4 варианта
  If xmir = 0
    ;{ если Х зеркала нет
    
    If ymir = 0
      ;{ если нет обоих зеркал
      
      ; стандартно, как раньше рисуем тайл
      
      ; сами циклы
      For y = starty To endy
        For x = startx To endx Step 2 ; перепрыгивать каждые 2
        
          ; читаем значение из памяти
          Number = PeekA(memory + k)
        
          ; раскладываем число на 2 пикселя. по 4 бита на пиксель
          first  = Number >> 4 ; сдвиг
          second = Number & $F ; отсечение по маске.
          ; рисуем точки с нужными цветами
          Plot(x,     y, PalNum(pal)\ColorNum[first])
          Plot(x + 1, y, PalNum(pal)\ColorNum[second])
        
          ; сдвиг по памяти дальше
          k + 1
        
        Next
      Next  
      ;}
    Else
      ;{ то есть Y зеркало все-таки есть
      
      ; сами циклы
      For y = endy To starty Step -1
        For x = startx To endx Step 2 ; перепрыгивать каждые 2
        
          ; читаем значение из памяти
          Number = PeekA(memory + k)
        
          ; раскладываем число на 2 пикселя. по 4 бита на пиксель
          first  = Number >> 4 ; сдвиг
          second = Number & $F ; отсечение по маске.
          ; рисуем точки с нужными цветами
          Plot(x,     y, PalNum(pal)\ColorNum[first])
          Plot(x + 1, y, PalNum(pal)\ColorNum[second])
        
          ; сдвиг по памяти дальше
          k + 1
        
        Next
      Next 
      ;}
    EndIf
    ;}
  Else
    ;{ X зеркало есть
    
    If ymir = 0
      ;{ Y нету
      
      ; сами циклы
      For y = starty To endy
        ; y точно такой-же
        
        ; а вот цикл для Х меняется не с начала на конец, а с конца на начало
        For x = endx To startx Step -2 ; перепрыгивать каждые 2
         
          ; читаем значение из памяти
          Number = PeekA(memory + k)
        
          ; раскладываем число на 2 пикселя. по 4 бита на пиксель
          first  = Number >> 4 ; сдвиг
          second = Number & $F ; отсечение по маске.
          ; рисуем точки с нужными цветами
          Plot(x,     y, PalNum(pal)\ColorNum[first])
          Plot(x - 1, y, PalNum(pal)\ColorNum[second]) ; вторая точка левее первой и поэтому -1
        
          ; сдвиг по памяти дальше
          k + 1
        
        Next
      Next  
      ;}
    Else
      ;{ самый жопный случай и Х и У зеркала
      
      ; сами циклы
      For y = endy To starty Step -1
        
        ; а вот цикл для Х меняется не с начала на конец, а с конца на начало
        For x = endx To startx Step -2 ; перепрыгивать каждые 2
         
          ; читаем значение из памяти
          Number = PeekA(memory + k)
        
          ; раскладываем число на 2 пикселя. по 4 бита на пиксель
          first  = Number >> 4 ; сдвиг
          second = Number & $F ; отсечение по маске.
          ; рисуем точки с нужными цветами
          Plot(x,     y, PalNum(pal)\ColorNum[first])
          Plot(x - 1, y, PalNum(pal)\ColorNum[second]) ; вторая точка левее первой и поэтому -1
        
          ; сдвиг по памяти дальше
          k + 1
        
        Next
      Next 
      ;}
    EndIf
    ;}
  EndIf
  
EndProcedure
;}

;{ процедура обновления гаджета в зависимости от галок сетка и граница экрана вкл выкл
Procedure Canvas01Update() ; основной экран с картинкой
  
  If StartDrawing(CanvasOutput(#ScreenCanvas))
    ; сначала черный фон
    Box(0, 0, 512, 224, RGB(0, 0, 0))
    
    x = 0 : y = 0 ; координаты первого тайла ставим как 0:0
    
    ; читаем тайловую карту - по 2 байта за раз
    For mem = tmapmemory To tmapmemory + tmapsize - 1 Step 2
      ; то есть гонять будем от tmapmemory - начала памяти, где тайловая карта лежит
      ; и до tmapmemory + tmapsize, то есть начало + размер. -1 чтобы не проскочило конец файла
      ; и step 2 - прыгать через каждые 2 байта
      
      ; поскольку стандартные методы PB читают word не в том порядке, как старые приставки
      ; то придется читать по 1 байту и сдвигать << 8 чтобы получить правильный порядок
      tmapvalue.u = PeekA(mem)
      tmapvalue   = tmapvalue << 8
      tmapvalue   = tmapvalue + PeekA(mem + 1)
    
      ; разбор двухбайтового значения на параметры
      prioritet = TestBit(tmapvalue, NumToBit(15))
      palnum    = GetBits(tmapvalue, 13, 14)
      vertical  = TestBit(tmapvalue, NumToBit(12))          
      horiz     = TestBit(tmapvalue, NumToBit(11))
      tnum      = GetBits(tmapvalue, 0, 10)
      
      ; заказываем отрисовку нужного тайла. пока без зеркал
      RisuemTile(x, y, tsetmemory + (tnum * 32), palnum + 1, horiz, vertical)
      ; передвигаем значения х дальше на 8 пикселей для следующего тайла
      x + 8
      ; проверяем достигли ли конца экрана по х и если да, то обнуляем, а y двигаем +8 вниз
      If x = 512
        x = 0
        y + 8
        ; проверяем не превысили ли по высоте, а то мало ли
        If y > 216
          Break
        EndIf
      EndIf
      
    Next
    
    ; проверить не чекнута ли граница
    If Granica
      ; значит чекнута и рисуем вертикальную линию границы экрана
      Line(320, 0, 1, 224, BorderColor)
    EndIf
    
    ; проверить не чекнута ли сетка
    If Setka
      ; значит чекнута. 
      ; сначала включаем режим полупрозрачного рисования
      DrawingMode(#PB_2DDrawing_AlphaBlend)
      ; двумя циклами рисуем полупрозрачные вертикальные и горизонтальные линии
      For x = 7 To 512 Step 8
        ; вертикальные
        Line(x, 0, 1, 224, GreedColor)
      Next
      For y = 7 To 224 Step 8
        ; горизонтальные
        Line(0, y, 520, 1, GreedColor)
      Next
    EndIf
    
    StopDrawing()
  EndIf 
  
EndProcedure
;}

;{ процедура обновления дополнительного гаджета в зависимости от галок сетка и граница экрана вкл выкл
Procedure Canvas02Update() ; дополнительный экран с приоритетом и зеркалами
  
  If StartDrawing(CanvasOutput(#PrioritetMirrorsCanvas))
    ; сначала черный фон
    Box(0, 0, 512, 224, RGB(0, 0, 0))
    
    x = 0 : y = 0 ; координаты первого тайла ставим как 0:0
    
    ; читаем тайловую карту - по 2 байта за раз
    For mem = tmapmemory To tmapmemory + tmapsize - 1 Step 2
      ; то есть гонять будем от tmapmemory - начала памяти, где тайловая карта лежит
      ; и до tmapmemory + tmapsize, то есть начало + размер. -1 чтобы не проскочило конец файла
      ; и step 2 - прыгать через каждые 2 байта
      
      ; поскольку стандартные методы PB читают word не в том порядке, как старые приставки
      ; то придется читать по 1 байту и сдвигать << 8 чтобы получить правильный порядок
      tmapvalue.u = PeekA(mem)
      tmapvalue   = tmapvalue << 8
      tmapvalue   = tmapvalue + PeekA(mem + 1)
    
      ; разбор двухбайтового значения на параметры
      prioritet = TestBit(tmapvalue, NumToBit(15))
      palnum    = GetBits(tmapvalue, 13, 14)
      vertical  = TestBit(tmapvalue, NumToBit(12))          
      horiz     = TestBit(tmapvalue, NumToBit(11))
      tnum      = GetBits(tmapvalue, 0, 10)
      
      ; отрисовка обозначения приоритета, если приоритет есть
      If prioritet
        ; тайл будет чуть светлее, чем черный
        Box(x, y, 8, 8, RGB(80, 80, 80))
      EndIf
      ; отрисовка зеркала по горизонтали
      If horiz
        Line(x + 1, y + 2, 3, 3, BorderColor)
        Line(x + 1, y + 4, 3, -3, BorderColor)
        Plot(x + 1, y + 1, BorderColor)
        Plot(x + 3, y + 1, BorderColor)
        Plot(x + 1, y + 5, BorderColor)
        Plot(x + 3, y + 5, BorderColor)
      EndIf
      ; по вертикали
      If vertical
        Line(x + 4, y + 1, 1, 2, BorderColor)
        Line(x + 6, y + 1, 1, 2, BorderColor)
        Line(x + 5, y + 3, 1, 3, BorderColor)
      EndIf

      ; передвигаем значения х дальше на 8 пикселей для следующего тайла
      x + 8
      ; проверяем достигли ли конца экрана по х и если да, то обнуляем, а y двигаем +8 вниз
      If x = 512
        x = 0
        y + 8
        ; проверяем не превысили ли по высоте, а то мало ли
        If y > 216
          Break
        EndIf
      EndIf
      
    Next
    
    ; проверить не чекнута ли граница
    If Granica
      ; значит чекнута и рисуем вертикальную линию границы экрана
      Line(320, 0, 1, 224, BorderColor)
    EndIf
    
    ; проверить не чекнута ли сетка
    If Setka
      ; значит чекнута. 
      ; сначала включаем режим полупрозрачного рисования
      DrawingMode(#PB_2DDrawing_AlphaBlend)
      ; двумя циклами рисуем полупрозрачные вертикальные и горизонтальные линии
      For x = 7 To 512 Step 8
        ; вертикальные
        Line(x, 0, 1, 224, GreedColor)
      Next
      For y = 7 To 224 Step 8
        ; горизонтальные
        Line(0, y, 520, 1, GreedColor)
      Next
    EndIf
    
    StopDrawing()
  EndIf 
  
EndProcedure
;}

;- Window
If OpenWindow(#Window, 100, 100, 530, 530, "Якубович под грибами играет в Сегу", #PB_Window_MinimizeGadget | #PB_Window_ScreenCentered)
  
  ; для палитры
  CanvasGadget(#PalCanvas, 10, 10, 160, 40)
  
  ; для экрана
  CanvasGadget(#ScreenCanvas, 10, 60, 512, 224)
  
  OptionGadget(#ColorGreen, 220, 10, 50, 20, "зел")
  OptionGadget(#ColorPurple, 290, 10, 50, 20, "фиол")
  OptionGadget(#ColorBlack, 370, 10, 50, 20, "черн")
  ; отмечаем что изначально выбран зеленый
  SetGadgetState(#ColorGreen, 1)
  
  CheckBoxGadget(#CheckBoxBorder, 250, 30, 60, 20, "граница")
  CheckBoxGadget(#CheckBoxGreed, 350, 30, 60, 20, "сетка")
  
  CanvasGadget(#PrioritetMirrorsCanvas, 10, 295, 512, 224)
  
  ButtonGadget(#Test, 440, 15, 50, 30, "ТЕСТ")
  
  ;{ отрисовка палитры в окне палитры #PalCanvas
  If StartDrawing(CanvasOutput(#PalCanvas))
    
    ; сначала черный фон
    Box(0, 0, 200, 40, RGB(0, 0, 0)) ; это черный цвет. в принципе можно было просто 0 написать вместо RGB(0, 0, 0)
  
    y = 0 ; первая палитра начнет рисоваться с самого верха 
    ; стартанем цикл в цикле с перебором всех ячеек в нашем массиве палитр
    For Pal = 1 To 4
      ; гоняем все 4 палитры
      
      ; на входе в цвета сбрасываем координату Х на начало картинки
      x = 0
      For ColorNumIndex = 0 To 15
        ; гоняем все цвета в конкретной палитре
        
        ; рисуем кубик 10х10 пикселей с цветом из палитры
        Box(x, y, 10, 10, PalNum(Pal)\ColorNum[ColorNumIndex])
        
        ; сдвигаем координату вправо для следующего цвета
        x + 10 
      Next
      ; когда достигли последнего 16 цвета в палитре - сдвигаем координату на одну строчку ниже
      y + 10
    Next
    
    ; остановка рисования
    StopDrawing()
  EndIf
  ;}
  
  ;{ вызов процедуры отрисовки в канвасе экрана
  Canvas01Update()
  ;}
  
  ;{ вызов процедуры отрисовки в канвасе дополнительном
  Canvas02Update()
  ;}
  
  
  Repeat
    Select WaitWindowEvent()

      Case #PB_Event_Gadget

        Select EventGadget()
           
          Case #CheckBoxBorder ;{ действия с чекбоксом границы
            If EventType() = #PB_EventType_LeftClick
              ; загоняем чекнутость чекбокса в глобальную переменную
              Granica = GetGadgetState(#CheckBoxBorder)
              ; и заказываем перерисовку всего главного канваса
              Canvas01Update()
              ; так-же перерисовку вспомогательного канваса
              Canvas02Update()
            EndIf
            ;}
            
          Case #CheckBoxGreed ;{ действия с чекбоксом сетки
            If EventType() = #PB_EventType_LeftClick
              ; загоняем чекнутость чекбокса в глобальную переменную
              Setka = GetGadgetState(#CheckBoxGreed)
              ; и заказываем перерисовку всего главного канваса
              Canvas01Update()
              ; так-же перерисовку вспомогательного канваса
              Canvas02Update()
            EndIf
            ;}
            
          Case #ColorGreen ;{ выбор цвета
            If EventType() = #PB_EventType_LeftClick
              BorderColor = RGB(0, 200, 0)
              GreedColor  = RGBA(0, 200, 0, 100)
              Canvas01Update()
              Canvas02Update()
            EndIf
          Case #ColorPurple
            If EventType() = #PB_EventType_LeftClick
              BorderColor = RGB(255, 0, 255)
              GreedColor  = RGBA(255, 0, 255, 100)
              Canvas01Update()
              Canvas02Update()
            EndIf
          Case #ColorBlack
            If EventType() = #PB_EventType_LeftClick
              BorderColor = RGB(0, 0, 0)
              GreedColor  = RGBA(0, 0, 0, 100)
              Canvas01Update()
              Canvas02Update()
            EndIf            
            ;}
            
          Case #Test ;{ кнопка теста экрана в эмуляторе
            If EventType() = #PB_EventType_LeftClick
              ; в начале сборка рома
              ; запускаем наконец ASM68K.EXE с нужными параметрами для сборки рома
              RunProgram("ASM68K.EXE", "/p test_pic.asm,test_pic.bin", "")
              ; добавляем паузу, пока асм собирает ром
              Delay(500)
              ; проверяем размер файла нашего рома test_pic.bin
              sz = FileSize("test_pic.bin")
              If sz > 0
                ; если размер больше нуля, значит все хорошо и ром собрался
                
                ; тут надо изменить путь на свой!!!!!!!!!!!!!!!
                EmulatorPath$ = "D:\SEGA\Gens_R57Shell_mods\Gens_R57Shell_mod.exe"
                
                ; запускаем эмулятор и в качестве параметра указываем название нашего рома
                RunProgram(EmulatorPath$, "test_pic.bin", "")
                
              Else
                ; случилась какая-то фигня и ром не собрался. 
                ; вывести ошибку и предложить запустить батник отдельно, чтоб почитать окошко
                Result = MessageRequester("ошибка", "ром не собрался. запустить батник, чтобы почитать какая ошибка не дает собраться рому?", #PB_MessageRequester_YesNo)
                If Result = #PB_MessageRequester_Yes
                  ; пользователь на все согласный, значит стартуем батник.
                  RunProgram("build.bat")
                EndIf
              EndIf
            EndIf
            ;}
            
        EndSelect

      Case #PB_Event_CloseWindow
        qiut = 1
   
    EndSelect
  Until qiut = 1

EndIf

End


; IDE Options = PureBasic 6.00 LTS (Windows - x86)
; CursorPosition = 307
; FirstLine = 53
; Folding = +wpvx
; EnableXP
; DPIAware