	org	0
	dc.l	0,RESET
	
;	org	$78
;	dc.l	VBLANK

	org	$100
	dc.l	'SEGA'
	
	org	$200
	include	std_init.asm
	
	lea	$C00000,a1 ; VDP CONTROL PORT
	lea	4(a1),a2   ; VDP DATA PORT
	
	lea	pic_vdp_settings,a0
	move.w	#$8000,d0
	move.w	#$0100,d2
	moveq	#15,d1
@load_vdp_params
	move.b	(a0)+,d0
	move.w	d0,(a2)
	add.w	d2,d0	
	dbf	d1,@load_vdp_params
	
	;lea	pic_palette,a0
	move.l	#$C0000000,(a2) ; VDP PORT ADDRESS CRAM
	moveq	#128/32-1,d1
	bsr.s	copy_to_vram
	
	move.l	#$40000000,(a2) ; VDP PORT ADDRESS VRAM $0000
	moveq	#7,d1
	moveq	#0,d0
@clr_vram_tile0
	move.l	d0,(a1)
	dbf	d1,@clr_vram_tile0
	
	;lea	pic_tiles,a0
	;move.l	#$40200000,(a2) ; VDP PORT ADDRESS VRAM $0020
	move.w	#(pic_tiles_end-pic_tiles)/32-1,d1
	bsr.s	copy_to_vram
	
	lea	pic_map1,a0
	move.l	#$40000003,(a2) ; VDP PORT ADDRESS VRAM $C000 - MAP1
	move.w	#$0001,d3
	bsr.s	load_map_64x28

	;lea	pic_map2,a0
	;move.l	#$60000003,(a2) ; VDP PORT ADDRESS VRAM $E000 - MAP2
	;move.w	#$0001,d3	; base tile num
	;bsr.s	load_map_40x28


	move.w	#$8144,(a2)	; DISPLAY ON
	
	
	move.w	#10*60,d0	; 5 seconds
wait	
	bsr	wait_next_frame
	dbf	d0,wait
	
	
	;move.w	#$8104,(a2)	; DISPLAY oFF
	
asdasf	
	jmp	asdasf
	
	
wait_next_frame:
Vdp_wait_NoVBL:
		btst	#3,1(a2)
		bne.s	Vdp_wait_NoVBL

Vdp_wait_VBL:
		btst	#3,1(a2)
		beq.s	Vdp_wait_VBL
		rts
; End of function Vdp_wait_VBL
	
	
	
copy_to_vram
	move.l	(a0)+,(a1)
	move.l	(a0)+,(a1)
	move.l	(a0)+,(a1)
	move.l	(a0)+,(a1)
	move.l	(a0)+,(a1)
	move.l	(a0)+,(a1)
	move.l	(a0)+,(a1)
	move.l	(a0)+,(a1)
	dbf	d1,copy_to_vram
	rts
	
	
load_map_64x28:
	move.l	#64*28-1,d1
@copy_n
	move.w	(a0)+,d0
	add.w	d3,d0
	move.w	d0,(a1)
	dbf	d1,@copy_n
	rts

load_map_40x28:		; map 40x28 -> 64x28 conversion
	moveq	#27,d2
	moveq	#0,d4
@copy_n
	moveq	#63,d1 ; 39
@copy_l
	move.w	(a0)+,d0
	add.w	d3,d0
	move.w	d0,(a1)
	dbf	d1,@copy_l
	moveq	#0,d1 ; 23
@fill_l:
	move.w	d3,(a1)
	dbf	d1,@fill_l
	dbf	d2,@copy_n
	rts
	
	
pic_vdp_settings:
	dc.b    $04 ; h-int off
	dc.b	$04 ; disp off, dma off, v28
	dc.b	$38 ; planA - $E000
	dc.b	$38 ; window - $E000
	dc.b	$06 ; planB - $C000
	dc.b	$78 ; sprites - $F000
	dc.b	$00 ; unused
	dc.b	$00 ; backdrop color
	dc.b	$00 ; unused
	dc.b	$00 ; unused
	dc.b	$FF ; h-int value
	dc.b	$00 ; full v/h scroll
	dc.b	$81 ; 320x224, s/h off
	dc.b	$3D ; hscroll table
	dc.b	$00 ; unused
	dc.b	$02 ; auto-inc 2

	
pic_palette:
	incbin	pal.bin
pic_tiles:
	incbin	tset.bin
pic_tiles_end:
	
pic_map1:
	incbin	tmap.bin
;pic_map2:
;	incbin	L2Map.BIN

